<template>
  <div :class="`mt-chevrons ${type} ${mobileStyle}`" :title="title">
    <button :class="`mt-chevron ${type}`" @click="$emit('click')">
      <b-icon size="is-medium" :icon="`chevron-${type}`" />
    </button>
    <div class="mt-chevron-texte">
      <slot></slot>
    </div>
  </div>
</template>

<script>
export default {
  name: 'MtChevron',
  props: {
    isMobile: Boolean,
    type: {
      validator(value) {
        return ['left', 'right'].includes(value);
      },
      required: true,
    },
    title: {
      type: String,
      default: () => '',
    },
  },
  computed: {
    mobileStyle() {
      if (this.isMobile) {
        return 'mt-chevron-mobile';
      }
      return '';
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

/*
En mode "desktop", les flèches sont sorties de leur container pour aller sur le calendrier.
En mode "tablette/téléphone", les flèches reviennent dans leur container au-dessus du calendrier.
 */
.mt-chevrons {
  position: absolute;
  display: flex;
  top: 0;
  bottom: 0;
  align-items: center;
  --chevron-size: 44px;
  padding-top: 1.5rem;

  &.mt-chevron-mobile {
    display: none;
    position: relative;
    top: unset;
    bottom: unset;
    justify-content: center;

    &.left {
      left: unset;
    }

    &.right {
      right: unset;
    }
  }

  .mt-chevron-texte {
    position: absolute;
    color: $brown-grey;
    font-size: 0.75rem;
    text-transform: uppercase;
    font-weight: bold;
    cursor: default;
    white-space: nowrap;
  }

  &.left {
    left: calc(-1 * var(--chevron-size) / 2);
    flex-direction: row-reverse;

    .mt-chevron-texte {
      right: calc(var(--chevron-size) + 0.35em);
    }
  }

  &.right {
    right: calc(-1 * var(--chevron-size) / 2);

    .mt-chevron-texte {
      left: calc(var(--chevron-size) + 0.35em);
    }
  }

  .mt-chevron {
    position: relative;
    z-index: 9;
    width: var(--chevron-size);
    height: var(--chevron-size);
    display: flex;
    align-items: center;
    justify-content: center;
    box-shadow: 0 1px 8px -1px rgba(102, 110, 232, 0.2);
    border-radius: 50%;
    background-color: $white;
    color: $grey-dark;
    cursor: pointer;
    transition-property: color, background-color;
    transition-duration: 0.3s;
    border: 0;

    &:hover {
      color: $primary;
    }

    &:active {
      background-color: $pale-grey;
    }
  }
}
@media screen and (max-width: 768px) {
  .mt-chevrons {
    --chevron-size: 38px;
    display: none;
    padding: 0.2rem;

    &.mt-chevron-mobile {
      display: flex;
    }
    .mt-chevron {
      box-shadow: unset;
      background-color: transparent;
    }
  }
  .mt-chevron-texte {
    display: none;
  }
}
</style>
